# coding: utf-8

"""
    Zarban Wallet API

    API for Zarban wallet services.  # noqa: E501

    The version of the OpenAPI document: 2.0.0
    Generated by: https://openapi-generator.tech
"""


import pprint
import re  # noqa: F401

import six

from zarban.wallet.openapi_client.configuration import Configuration


class ProfileResponse(object):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.
    """

    """
    Attributes:
      openapi_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    openapi_types = {
        'transactions': 'list[Transaction]',
        'referral': 'Referral',
        'points': 'int',
        'avatar': 'str',
        'telegram': 'TelegramProfile',
        'user': 'User'
    }

    attribute_map = {
        'transactions': 'transactions',
        'referral': 'referral',
        'points': 'points',
        'avatar': 'avatar',
        'telegram': 'telegram',
        'user': 'user'
    }

    def __init__(self, transactions=None, referral=None, points=None, avatar=None, telegram=None, user=None, local_vars_configuration=None):  # noqa: E501
        """ProfileResponse - a model defined in OpenAPI"""  # noqa: E501
        if local_vars_configuration is None:
            local_vars_configuration = Configuration()
        self.local_vars_configuration = local_vars_configuration

        self._transactions = None
        self._referral = None
        self._points = None
        self._avatar = None
        self._telegram = None
        self._user = None
        self.discriminator = None

        self.transactions = transactions
        self.referral = referral
        self.points = points
        self.avatar = avatar
        if telegram is not None:
            self.telegram = telegram
        self.user = user

    @property
    def transactions(self):
        """Gets the transactions of this ProfileResponse.  # noqa: E501


        :return: The transactions of this ProfileResponse.  # noqa: E501
        :rtype: list[Transaction]
        """
        return self._transactions

    @transactions.setter
    def transactions(self, transactions):
        """Sets the transactions of this ProfileResponse.


        :param transactions: The transactions of this ProfileResponse.  # noqa: E501
        :type: list[Transaction]
        """
        if self.local_vars_configuration.client_side_validation and transactions is None:  # noqa: E501
            raise ValueError("Invalid value for `transactions`, must not be `None`")  # noqa: E501

        self._transactions = transactions

    @property
    def referral(self):
        """Gets the referral of this ProfileResponse.  # noqa: E501


        :return: The referral of this ProfileResponse.  # noqa: E501
        :rtype: Referral
        """
        return self._referral

    @referral.setter
    def referral(self, referral):
        """Sets the referral of this ProfileResponse.


        :param referral: The referral of this ProfileResponse.  # noqa: E501
        :type: Referral
        """
        if self.local_vars_configuration.client_side_validation and referral is None:  # noqa: E501
            raise ValueError("Invalid value for `referral`, must not be `None`")  # noqa: E501

        self._referral = referral

    @property
    def points(self):
        """Gets the points of this ProfileResponse.  # noqa: E501


        :return: The points of this ProfileResponse.  # noqa: E501
        :rtype: int
        """
        return self._points

    @points.setter
    def points(self, points):
        """Sets the points of this ProfileResponse.


        :param points: The points of this ProfileResponse.  # noqa: E501
        :type: int
        """
        if self.local_vars_configuration.client_side_validation and points is None:  # noqa: E501
            raise ValueError("Invalid value for `points`, must not be `None`")  # noqa: E501

        self._points = points

    @property
    def avatar(self):
        """Gets the avatar of this ProfileResponse.  # noqa: E501

        Avatar URL, lottie file URL  # noqa: E501

        :return: The avatar of this ProfileResponse.  # noqa: E501
        :rtype: str
        """
        return self._avatar

    @avatar.setter
    def avatar(self, avatar):
        """Sets the avatar of this ProfileResponse.

        Avatar URL, lottie file URL  # noqa: E501

        :param avatar: The avatar of this ProfileResponse.  # noqa: E501
        :type: str
        """

        self._avatar = avatar

    @property
    def telegram(self):
        """Gets the telegram of this ProfileResponse.  # noqa: E501


        :return: The telegram of this ProfileResponse.  # noqa: E501
        :rtype: TelegramProfile
        """
        return self._telegram

    @telegram.setter
    def telegram(self, telegram):
        """Sets the telegram of this ProfileResponse.


        :param telegram: The telegram of this ProfileResponse.  # noqa: E501
        :type: TelegramProfile
        """

        self._telegram = telegram

    @property
    def user(self):
        """Gets the user of this ProfileResponse.  # noqa: E501


        :return: The user of this ProfileResponse.  # noqa: E501
        :rtype: User
        """
        return self._user

    @user.setter
    def user(self, user):
        """Sets the user of this ProfileResponse.


        :param user: The user of this ProfileResponse.  # noqa: E501
        :type: User
        """
        if self.local_vars_configuration.client_side_validation and user is None:  # noqa: E501
            raise ValueError("Invalid value for `user`, must not be `None`")  # noqa: E501

        self._user = user

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.openapi_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, ProfileResponse):
            return False

        return self.to_dict() == other.to_dict()

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        if not isinstance(other, ProfileResponse):
            return True

        return self.to_dict() != other.to_dict()
